﻿# This script exports the current selected geometry (nodes + triangles)
# for further update with updateNodesFromDna.py script
#
# arguments:
#  /path/to/mesh.k

 
# author: Matthieu MEAR date: 2017

import sys
import os
import os.path
import shutil

import piper.hbm
import piper.app


def writeLsDyna(fem, nodeIds, elem2DIds, elem3DIds, LsDynaPath):
    # gather node ids from nodes and elements
    allNodeIds = set()

    entityNamesArray = []
    faceIndex = 0

    with open(LsDynaPath, 'w') as LsDyna:
        piper.app.logInfo("Writing dyna file {0} ...".format(LsDynaPath))
        LsDyna.write("$# File generated by the PIPER application\n")
        LsDyna.write("*KEYWORD\n")
        LsDyna.write("*ELEMENT_SHELL\n")

        for id in nodeIds:
            allNodeIds.add(id)

        #2D ELEMENTS
        for entityName in elem2DIds:
            if entityName not in entityNamesArray:
                entityNamesArray.append(entityName)
            if len(elem2DIds) > 0:
                for elemId in elem2DIds[entityName]:
                    elem = fem.getElement2D(elemId)
                    ids = elem.get()
                    if elem.getType() == piper.hbm.ELT_QUAD:
                        LsDyna.write("{:>8}{:>8}{:>8}{:>8}{:>8}{:>8}\n".format(faceIndex, entityNamesArray.index(entityName)+1, ids[0], ids[1], ids[2], ids[3]))
                    else:
                        LsDyna.write("{:>8}{:>8}{:>8}{:>8}{:>8}\n".format(faceIndex, entityNamesArray.index(entityName)+1, ids[0], ids[1], ids[2]))
                    for id in ids:
                        allNodeIds.add(id)
                    faceIndex = faceIndex+1
                    
        #3D ELEMENTS
        for entityName in elem3DIds:
            if entityName not in entityNamesArray:
                entityNamesArray.append(entityName)
            for elemId in elem3DIds[entityName]:
                elem = fem.getElement3D(elemId)
                ids = elem.get()
                #HEXAHEDRON
                if elem.getType() == piper.hbm.ELT_HEXA:
                    LsDyna.write("{:>8}{:>8}{:>8}{:>8}{:>8}{:>8}\n".format(faceIndex, entityNamesArray.index(entityName)+1, ids[0], ids[1], ids[2], ids[3]))
                    LsDyna.write("{:>8}{:>8}{:>8}{:>8}{:>8}{:>8}\n".format(faceIndex+1, entityNamesArray.index(entityName)+1, ids[0], ids[4], ids[7], ids[3]))
                    LsDyna.write("{:>8}{:>8}{:>8}{:>8}{:>8}{:>8}\n".format(faceIndex+2, entityNamesArray.index(entityName)+1, ids[3], ids[7], ids[6], ids[2]))
                    LsDyna.write("{:>8}{:>8}{:>8}{:>8}{:>8}{:>8}\n".format(faceIndex+3, entityNamesArray.index(entityName)+1, ids[1], ids[5], ids[6], ids[2]))
                    LsDyna.write("{:>8}{:>8}{:>8}{:>8}{:>8}{:>8}\n".format(faceIndex+4, entityNamesArray.index(entityName)+1, ids[0], ids[4], ids[5], ids[1]))
                    LsDyna.write("{:>8}{:>8}{:>8}{:>8}{:>8}{:>8}\n".format(faceIndex+5, entityNamesArray.index(entityName)+1, ids[4], ids[5], ids[6], ids[7]))
                    faceIndex = faceIndex+6
                #TETRAHEDRON
                if elem.getType() == piper.hbm.ELT_TETRA:
                    LsDyna.write("{:>8}{:>8}{:>8}{:>8}{:>8}\n".format(faceIndex, entityNamesArray.index(entityName)+1, ids[0], ids[1], ids[2]))
                    LsDyna.write("{:>8}{:>8}{:>8}{:>8}{:>8}\n".format(faceIndex+1, entityNamesArray.index(entityName)+1, ids[0], ids[3], ids[2]))
                    LsDyna.write("{:>8}{:>8}{:>8}{:>8}{:>8}\n".format(faceIndex+2, entityNamesArray.index(entityName)+1, ids[2], ids[3], ids[1]))
                    LsDyna.write("{:>8}{:>8}{:>8}{:>8}{:>8}\n".format(faceIndex+3, entityNamesArray.index(entityName)+1, ids[0], ids[3], ids[1]))
                    faceIndex = faceIndex + 4
                #PENTAHEDRON
                if elem.getType() == piper.hbm.ELT_PENTA:
                    LsDyna.write("{:>8}{:>8}{:>8}{:>8}{:>8}{:>8}\n".format(faceIndex, entityNamesArray.index(entityName)+1, ids[0], ids[1], ids[2], ids[3]))
                    LsDyna.write("{:>8}{:>8}{:>8}{:>8}{:>8}{:>8}\n".format(faceIndex+1, entityNamesArray.index(entityName)+1, ids[0], ids[4], ids[5], ids[3]))
                    LsDyna.write("{:>8}{:>8}{:>8}{:>8}{:>8}\n".format(faceIndex+2, entityNamesArray.index(entityName)+1, ids[0], ids[4], ids[1]))
                    LsDyna.write("{:>8}{:>8}{:>8}{:>8}{:>8}\n".format(faceIndex+3, entityNamesArray.index(entityName)+1, ids[3], ids[5], ids[2]))
                    LsDyna.write("{:>8}{:>8}{:>8}{:>8}{:>8}{:>8}\n".format(faceIndex+4, entityNamesArray.index(entityName)+1, ids[1], ids[4], ids[5], ids[2]))  
                    faceIndex = faceIndex + 5
                #PYRAMID               
                if elem.getType() == piper.hbm.ELT_PYRA:
                    LsDyna.write("{:>8}{:>8}{:>8}{:>8}{:>8}{:>8}\n".format(faceIndex, entityNamesArray.index(entityName)+1, ids[0], ids[1], ids[2], ids[3]))
                    LsDyna.write("{:>8}{:>8}{:>8}{:>8}{:>8}\n".format(faceIndex+1, entityNamesArray.index(entityName)+1, ids[0], ids[4], ids[3]))
                    LsDyna.write("{:>8}{:>8}{:>8}{:>8}{:>8}\n".format(faceIndex+2, entityNamesArray.index(entityName)+1, ids[3], ids[4], ids[2]))
                    LsDyna.write("{:>8}{:>8}{:>8}{:>8}{:>8}\n".format(faceIndex+3, entityNamesArray.index(entityName)+1, ids[2], ids[4], ids[1]))
                    LsDyna.write("{:>8}{:>8}{:>8}{:>8}{:>8}\n".format(faceIndex+4, entityNamesArray.index(entityName)+1, ids[0], ids[4], ids[1]))
                    faceIndex = faceIndex + 5
                #UNDEFINED
                if elem.getType() == piper.hbm.ELT_UNDEFINED:
                    LsDyna.write("{:>8}{:>8}".format(elemId, entityArrayIndex))
                    for id in ids:
                        LsDyna.write("{:>8}".format(id))
                    LsDyna.write('\n')

                for id in ids:
                    allNodeIds.add(id)
       
        LsDyna.write("*NODE\n")
        for nodeId in allNodeIds:
            coord = fem.getNode(nodeId).get().flatten()
            LsDyna.write("{:>8}{:>16}{:>16}{:>16}\n".format(nodeId, coord[0], coord[1], coord[2]))
        
        LsDyna.write("*PART\n")
        LsDyna.write("$#     PID     SECID       MID     EOSID      HGID      GRAV    ADPOPT      TMID\n")
        for entityName in entityNamesArray:
            LsDyna.write("{:>10}{:>10}{:>10}{:>10}{:>10}{:>10}{:>10}{:>10}\n".format(entityNamesArray.index(entityName)+1, 0, 0, 0, 0, 0, 0, 0))
        LsDyna.write("*END\n")

model = piper.app.Context.instance().project().model()
# if the model is empty, we can do nothing
if model.empty():
    piper.app.logWarning("Model is empty")
elif 2 != len(sys.argv) :
    raise RuntimeError("Invalid arguments")
else :
    metadata = model.metadata()
    modelVTK = model.fem().getFEModelVTK()
    nodeIds = modelVTK.getSelectedNodes()
    elem2DIds =  modelVTK.getSelectedElementsByEntities(2);
    elem3DIds =  modelVTK.getSelectedElementsByEntities(3);
    nbSelected2DElements= 0
    for entityName in elem2DIds:
        nbSelected2DElements = nbSelected2DElements+len(elem2DIds[entityName])
    nbSelected3DElements= 0
    for entityName in elem3DIds:
        nbSelected3DElements = nbSelected3DElements+len(elem3DIds[entityName])

    piper.app.logInfo("nb selected nodes: {0}".format(len(nodeIds)))
    piper.app.logInfo("nb selected 2D elements: {0}".format(nbSelected2DElements))
    piper.app.logInfo("nb selected 3D elements: {0}".format(nbSelected3DElements))
    writeLsDyna(model.fem(), nodeIds, elem2DIds, elem3DIds, sys.argv[1])
